#include <iostream>
using namespace std;

int main() {
    unsigned int N,Q;
    cin >> N >> Q; //broj ocevih kupovina - broj pitanja
    unsigned int p[N];
    unsigned long long d[N],k[Q];
    for(int i = 0; i<N; i++){
        cin >> d[i] >> p[i]; //dan oceve kupovine - broj pakovanja kupljenih tog dana
    }
    for(int j = 0; j<Q; j++){
        cin >> k[j]; //koliko je pojela pakovanja do tog dana
    }
    unsigned int dan;
    for(int j = 0; j<Q; j++){
        if(k[j] < d[0]){
            cout << "0" << endl;
        }
        else if(k[j] == d[0]){
            cout << "1" << endl;
        }
        else{
            unsigned int dan = 0;
            unsigned int pojedene = 0;
            for(int i = 0; i<N; i++){
                if(d[i] > dan){
                    dan = d[i];
                }
                if(dan > k[j]){
                    break;
                }
                if(p[i] > k[j]-d[i]+1){
                    pojedene += k[j]-d[i]+1;
                    break;
                }
                pojedene += p[i];
                dan += p[i];
            }
            cout << pojedene << endl;
        }
    }
    return 0;
}